// copyright 2002 Josh Levenberg, please see copying.txt
/* 
  Has declarations for most global variables
  OpenGL extension entry points
*/

#ifndef DLOD_MAIN_INCLUDE_H
#define DLOD_MAIN_INCLUDE_H
#include <jstring.h>
#include "vect3.h"
#include <vector>
#include <gl/glut.h>
#define  WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

extern vec3_t gAvatar;

enum { numCameras=3 };

struct camera_t
  {
    vec3_t mLocation;
    vec3_t mLookAt;
    vec_t  mFov;
  };

extern camera_t gCamera[numCameras];

extern vec_t gAvatarHeight;

extern int gWhichCamera;
extern bool gPaused;
extern int gWireframe;
extern int gDoCulling;

extern int gWidth, gHeight;
extern bool gFullScreen;
extern int gSavedWidth, gSavedHeight;

extern unsigned gStartTime;
extern unsigned gNumFrames;
extern double gNumOutputTris;
extern double gBandwidth;

extern FILE *gOutFile;

// -------------

// Should depend on resolution, field of view, and desired pixel error
// Only thing stopping this from being dynamic is no UI
#define ErrorRatio 600.0f

// ---- Functions exported by glutmain.cpp

void DefaultKeyboard(unsigned char key, int x, int y);

void ResetStats();
void PrintStats();
void Quit();
void SimulateKeys(const char *str);
// may return filename or a pointer to a static buffer
const char *FindFile(const char *filename);

#endif
