// copyright 2002 Josh Levenberg, please see copying.txt

/*
   Supports switching between various display methods.
*/
#ifndef DISPLAY_METHOD_H
#define DISPLAY_METHOD_H

typedef void (*voidfunc)();
typedef void (*kbdfunc)(unsigned char key, int x, int y);
struct DisplayMethodType
  {
    voidfunc init;
    voidfunc draw;
    voidfunc close;
    kbdfunc  keyboard;
    voidfunc printstats;
    voidfunc resetstats;
  };

enum { MaxDisplayMethods=10 };
extern int NumDisplayMethods;
extern DisplayMethodType gDisplayMethods[MaxDisplayMethods];
extern int gCurrentDisplay;

void InitDisplayMethods();
void SwitchToDisplay(int newdisplay);

#endif