// copyright 2002 Josh Levenberg, please see copying.txt
/* declarations needed for using various OpenGL extensions */

#ifndef GL_EXTENSIONS_H
#define GL_EXTENSIONS_H

#include "dlod.h"

// ---- OpenGL Extensions

  // Compiled Vertex Array extension:
  // glLockArraysEXT && glUnlockArraysEXT
extern bool gLockingSupported;
#ifdef _WIN32
typedef void (APIENTRY * PFNGLLOCKARRAYSEXTPROC)(GLint, GLsizei);
typedef void (APIENTRY * PFNGLUNLOCKARRAYSEXTPROC)();
extern PFNGLLOCKARRAYSEXTPROC glLockArraysEXT;
extern PFNGLUNLOCKARRAYSEXTPROC glUnlockArraysEXT;
#endif

extern bool gArrayRangeSupported;

#define GL_VERTEX_ARRAY_RANGE_NV 0x851D
#ifdef _WIN32
typedef void * (APIENTRY * PFNWGLAllocateMemoryNVPROC)(GLsizei, GLfloat, GLfloat, GLfloat);
typedef void   (APIENTRY * PFNWGLFreeMemoryNVPROC)(void *);
typedef void * (APIENTRY * PFNGLVertexArrayRangeNVPROC)(GLsizei, void *);
typedef void   (APIENTRY * PFNGLFlushVertexArrayRangeNVPROC)();
extern PFNWGLAllocateMemoryNVPROC       wglAllocateMemoryNV;
extern PFNWGLFreeMemoryNVPROC           wglFreeMemoryNV;
extern PFNGLVertexArrayRangeNVPROC      glVertexArrayRangeNV;
extern PFNGLFlushVertexArrayRangeNVPROC glFlushVertexArrayRangeNV;
#endif

extern bool gFenceSupported;

#define GL_ALL_COMPLETED_NV 0x84F2
#ifdef _WIN32
typedef void (APIENTRY * PFNGLGenFencesNVPROC)(GLsizei, GLuint *);
typedef void (APIENTRY * PFNGLSetFenceNVPROC)(GLsizei, GLenum);
typedef GLboolean (APIENTRY * PFNGLTestFenceNVPROC)(GLuint);
typedef void (APIENTRY * PFNGLFinishFenceNVPROC)(GLuint);
typedef void (APIENTRY * PFNGLDeleteFencesNVPROC)(GLsizei, const GLuint *);
typedef GLboolean (APIENTRY * PFNGLIsFenceNVPROC)(GLuint);
typedef void (APIENTRY * PFNGLGetFenceivNVPROC)(GLuint, GLenum, GLint *);
extern PFNGLGenFencesNVPROC glGenFencesNV;
extern PFNGLSetFenceNVPROC glSetFenceNV;
extern PFNGLTestFenceNVPROC glTestFenceNV;
extern PFNGLFinishFenceNVPROC glFinishFenceNV;
extern PFNGLDeleteFencesNVPROC glDeleteFencesNV;
extern PFNGLIsFenceNVPROC glIsFenceNV;
extern PFNGLGetFenceivNVPROC glGetFenceivNV;
#endif

extern bool gNVExtensions; // == gArrayRangeSupported && gFenceSupported

//extern bool gDrawRangeElementsSupported;
#ifdef _WIN32
typedef void (APIENTRY * PFNGLDrawRangeElementsPROC)(GLenum, GLuint, GLuint, GLsizei, GLenum, const GLvoid *);
extern PFNGLDrawRangeElementsPROC glDrawRangeElements;
#endif

#endif