// copyright 2002 Josh Levenberg, please see copying.txt
#include "assert.h"
#include <stdio.h>
#include <stdlib.h>

namespace Assert
  {
    AssertResult DefaultAssertFunction_Stdio(const char *file, unsigned line, 
                                        const char *expr)
      {
        fprintf(stderr, "Assertion failed: file: %s line: %d\n",
                file, line);
        fprintf(stderr, "expression: %s\n", expr);
        fprintf(stderr, "B>reak, S>kip, A>lways skip, or Q>uit? ");
        char c;
        fscanf(stdin, " %c", &c);
        if (c=='q' || c=='Q')
          exit(2);
        if (c=='s' || c=='S')
          return Skip;
        if (c=='a' || c=='A')
          return SkipAlways;
        return Break;
      }

    AssertFunction gAssertFunction=DefaultAssertFunction_Stdio;
  };
