// copyright 2002 Josh Levenberg, please see copying.txt
#include "dlod.h"
#include "screencap.h"
#include "pngwrap.h"

static int sCaptureCount=0;

void SetCaptureCount(int capturecount)
  {
    sCaptureCount=capturecount;
  }

static void ScreenBWCaptureToFile(char *filename)
  {
    unsigned char *screendata=new unsigned char[gWidth*gHeight];
    glFinish();
    glReadPixels( 0, 0,
                  gWidth, gHeight,
                  GL_GREEN,
                  GL_UNSIGNED_BYTE,
                  screendata);
    for (int row=0; row<gHeight/2; ++row)
      for (int col=0; col<gWidth; ++col)
        {
          unsigned char temp = screendata[row*gWidth+col];
          screendata[row*gWidth+col] = screendata[(gHeight-row-1)*gWidth+col];
          screendata[(gHeight-row-1)*gWidth+col] = temp;
        }
    write_png_8gray(filename, gWidth, gHeight, screendata);
    delete[] screendata;
  }

void ScreenBWCapture()
  {
    static char filename[13]={ "dlod0000.png" };
    filename[4]='0'+((sCaptureCount/1000)%10);
    filename[5]='0'+((sCaptureCount/100 )%10);
    filename[6]='0'+((sCaptureCount/10  )%10);
    filename[7]='0'+((sCaptureCount/1   )%10);
    ScreenBWCaptureToFile(filename);
    ++sCaptureCount;
  }

static void ScreenRGBPackedCapture(unsigned char *rgbpacked)
  {
    unsigned char *screendata[3];
    screendata[0]=new unsigned char[gWidth*gHeight];
    screendata[1]=new unsigned char[gWidth*gHeight];
    screendata[2]=new unsigned char[gWidth*gHeight];
    glFinish();
    glReadPixels( 0, 0,
                  gWidth, gHeight,
                  GL_RED,
                  GL_UNSIGNED_BYTE,
                  screendata[0]);
    glReadPixels( 0, 0,
                  gWidth, gHeight,
                  GL_GREEN,
                  GL_UNSIGNED_BYTE,
                  screendata[1]);
    glReadPixels( 0, 0,
                  gWidth, gHeight,
                  GL_BLUE,
                  GL_UNSIGNED_BYTE,
                  screendata[2]);

    for (int row=0; row<gHeight; ++row)
      for (int col=0; col<gWidth; ++col)
        for (int clr=0; clr<3; ++clr)
          {
            rgbpacked[(row*gWidth+col)*3+clr] = 
              screendata[clr][(gHeight-row-1)*gWidth+col];
          }
    delete[] screendata[2];
    delete[] screendata[1];
    delete[] screendata[0];
  }

void writergbfile(unsigned char *rgbdata)
  {
    static char filename[13]={ "dlod0000.png" };
    filename[4]='0'+((sCaptureCount/1000)%10);
    filename[5]='0'+((sCaptureCount/100 )%10);
    filename[6]='0'+((sCaptureCount/10  )%10);
    filename[7]='0'+((sCaptureCount/1   )%10);
    write_png_8rgb(filename, gWidth, gHeight, rgbdata);
    ++sCaptureCount;
  }

static int sFieldsCaptured=0;
unsigned char *sFieldBuffer=new unsigned char[gWidth*gHeight*3];
unsigned char *sScreenBuffer=new unsigned char[gWidth*gHeight*3];

void ScreenRGBCapture(int fields)
  {
    if (fields>0)
      {
        if (sFieldsCaptured==0)
          {
            ScreenRGBPackedCapture(sFieldBuffer);
          }
        else
          {
            ScreenRGBPackedCapture(sScreenBuffer);
            // copy 2nd field from sScreenBuffer to sFieldBuffer
            for (int row=0; row<gHeight; row+=2)
              {
                memcpy(&sFieldBuffer[row*gWidth*3],
                  &sScreenBuffer[row*gWidth*3], gWidth*3);
              }
            writergbfile(sFieldBuffer);
            --fields;
            if (fields) 
              { 
                unsigned char *temp=sFieldBuffer;
                sFieldBuffer=sScreenBuffer;
                sScreenBuffer=temp;
              }
          }
        while (fields>=2)
          {
            writergbfile(sFieldBuffer);
            fields -= 2;
          }
        sFieldsCaptured=fields;
      }
  }

