// copyright 2002 Josh Levenberg, please see copying.txt

/*
  There are 5 different UI's that can be used:
    DEMO_MOVIE and MOVIE_OUTPUT are legacy modes I used to create 
        demonstration movies for paper submission, they haven't been
        tested in a little while
    PROFILE_TEST_MODE runs a predefined battery of tests to create
        timing information.
    INTERACTIVE_MODE allows you to run around the heightfield under
        mouse control
    AUTOPILOT is like INTERACTIVE_MODE except it follows a set path.
        I used this when giving a presentation so I could switch 
        wireframe modes, rendering modes, and cameras and not worry
        about steering.  Note: AUTOPILOT mode requires that
        INTERACTIVE_MODE is defined.
    Only one of these modes should be selected at a time.
 */

#ifndef UI_TYPE_SELECTION_H
#define UI_TYPE_SELECTION_H

//#define DEMO_MOVIE  // see demomovie.cpp
//#define PROFILE_TEST_MODE // see profile.cpp
//#define MOVIE_OUTPUT // see movieout.cpp

#define INTERACTIVE_MODE // see interact.cpp
//#define AUTOPILOT     // only if INTERACTIVE_MODE

// defined in every UI file
void glutIdle();
void UIInit();
void UIKey(unsigned char key);
void UIPostDraw();
#ifdef DEMO_MOVIE
bool UIPreDraw();
#endif

#endif